require 'test_setup'

class AppTest
  include Minispec

  class App < Air
    def index
      __method__
    end
  end

  class JustAnotherApp < Air
    def another
      __method__
    end
  end

  before_all { app(App) }

  testing :response do
    get
    is(last_response).ok?
    assert(last_response.body) == 'index'
  end

  testing :cookies do
    cookies['foo'] = 'bar'
    get
    assert(cookies['foo']) == 'bar'
  end

  testing :headers do
    header['User-Agent'] = 'Rack::Radar'
    get
    assert(headers['User-Agent']) == 'Rack::Radar'
  end

  testing 'another app' do

    app(JustAnotherApp)

    are(cookies['foo']).nil?
    are(headers['User-Agent']).nil?

    get
    is(last_response).not_found?

    get :another
    is(last_response).ok?
  end

end
