require 'test_setup'

class SessionTest
  include Minispec

  class App < Air

    def index
      __method__
    end
  end

  class JustAnotherApp < Air
    def alone
      __method__
    end
  end

  let(:session) { Rack::Radar::RackRadarSession.new(App) }

  testing 'manually initialized session' do

    session.header['User-Agent'] = 'Rack::Radar'

    session.get
    is(session.last_response).ok?
    is(session.last_response.body) == 'index'

    is(session.last_request.env['HTTP_USER_AGENT']) == 'Rack::Radar'

    expect { session.reset_app! }.to_raise_error
  end

  testing 'app switcher' do
    session = Rack::Radar::RackRadarSession.new(JustAnotherApp)
    session.get
    is(session.last_response).not_found?

    session.get :alone
    is(session.last_response).ok?
  end
end
